<?php

class bt_bb_accordion extends BT_BB_Element {

	function handle_shortcode( $atts, $content ) {
		extract( shortcode_atts( apply_filters( 'bt_bb_extract_atts_' . $this->shortcode, array(
			'color_scheme' 			=> '',
			'style'        			=> '',
			'shape'        			=> '',
			'closed'       			=> '',
			'icon_style'   			=> '',
			'icons_color_scheme' 	=> ''
		) ), $atts, $this->shortcode ) );
		
		/*wp_enqueue_script(
			'bt_bb_accordion',
			get_template_directory_uri() . '/bold-page-builder/content_elements/bt_bb_accordion/bt_bb_accordion.js',
			array( 'jquery' ),
			'',
			true
		);*/

		$class = array( $this->shortcode );

		if ( $el_class != '' ) {
			$class[] = $el_class;
		}

		$id_attr = '';
		if ( $el_id != '' ) {
			$id_attr = ' ' . 'id="' . esc_attr( $el_id ) . '"';
		}

		$color_scheme_id = NULL;
		if ( is_numeric ( $color_scheme ) ) {
			$color_scheme_id = $color_scheme;
		} else if ( $color_scheme != '' ) {
			$color_scheme_id = bt_bb_get_color_scheme_id( $color_scheme );
		}
		$color_scheme_colors = bt_bb_get_color_scheme_colors_by_id( $color_scheme_id - 1 );
		if ( $color_scheme_colors ) $el_style .= '; --accordion-primary-color:' . $color_scheme_colors[0] . '; --accordion-secondary-color:' . $color_scheme_colors[1] . ';';
		if ( $color_scheme != '' ) $class[] = $this->prefix . 'color_scheme_' .  $color_scheme_id;


		$icons_color_scheme_id = NULL;
		if ( is_numeric ( $icons_color_scheme ) ) {
			$icons_color_scheme_id = $icons_color_scheme;
		} else if ( $icons_color_scheme != '' ) {
			$icons_color_scheme_id = bt_bb_get_color_scheme_id( $icons_color_scheme );
		}
		$icons_color_scheme_colors = bt_bb_get_color_scheme_colors_by_id( $icons_color_scheme_id - 1 );
		if ( $icons_color_scheme_colors ) $el_style .= '; --icons-primary-color:' . $icons_color_scheme_colors[0] . '; --icons-secondary-color:' . $icons_color_scheme_colors[1] . ';';
		if ( $icons_color_scheme != '' ) $class[] = $this->prefix . 'icons_color_scheme_' .  $icons_color_scheme_id;



		if ( $style != '' ) {
			$class[] = $this->prefix . 'style' . '_' . $style;
		}		

		if ( $shape != '' ) {
			$class[] = $this->prefix . 'shape' . '_' . $shape;
		}

		if ( $icon_style != '' ) {
			$class[] = $this->prefix . 'icon_style' . '_' . $icon_style;
		}

		$style_attr = '';
		if ( $el_style != '' ) {
			$style_attr = ' ' . 'style="' . esc_attr( $el_style ) . '"';
		}

		$data_attr = '';
		if ( $closed == 'closed' ) {
			$data_attr = ' ' . 'data-closed=closed';
		}
		
		$class = apply_filters( $this->shortcode . '_class', $class, $atts );

		$content = do_shortcode( $content );

		$output = '';

		$output .= '<div' . $id_attr . ' class="' . implode( ' ', $class ) . '"' . $style_attr . $data_attr . '>' . $content . '</div>';
		
		$output = apply_filters( 'bt_bb_general_output', $output, $atts );
		$output = apply_filters( $this->shortcode . '_output', $output, $atts );

		return $output;

	}

	function map_shortcode() {
		
		$color_scheme_arr = bt_bb_get_color_scheme_param_array();			
		
		bt_bb_map( $this->shortcode, array( 'name' => esc_html__( 'Accordion', 'bambino' ), 'description' => esc_html__( 'Accordion container', 'bambino' ), 'container' => 'vertical', 'accept' => array( 'bt_bb_accordion_item' => true ), 'icon' => $this->prefix_backend . 'icon' . '_' . $this->shortcode,
			'params' => array(
				array( 'param_name' => 'color_scheme', 'type' => 'dropdown', 'heading' => esc_html__( 'Color scheme', 'bambino' ), 'description' => esc_html__( 'Define color schemes in Bold Builder settings or define accent and alternate colors in theme customizer (if avaliable)', 'bambino' ), 'value' => $color_scheme_arr, 'preview' => true ),
				array( 'param_name' => 'style', 'type' => 'dropdown', 'heading' => esc_html__( 'Style', 'bambino' ), 'preview' => true,
					'value' => array(
						esc_html__( 'Outline', 'bambino' ) => 'outline',
						esc_html__( 'Filled', 'bambino' ) => 'filled',
						esc_html__( 'Simple', 'bambino' ) => 'simple'
					)
				),
				array( 'param_name' => 'shape', 'type' => 'dropdown', 'heading' => esc_html__( 'Shape', 'bambino' ),
					'value' => array(
						esc_html__( 'Inherit', 'bambino' ) 		=> '',
						esc_html__( 'Square', 'bambino' ) 		=> 'square',
						esc_html__( 'Rounded', 'bambino' ) 		=> 'rounded',
						esc_html__( 'Round', 'bambino' ) 		=> 'round'
					)
				),
				array( 'param_name' => 'icon_style', 'type' => 'dropdown', 'default' => '', 'heading' => esc_html__( 'Icon style', 'bambino' ),
					'value' => array(
						esc_html__( 'Filled', 'bambino' ) 		=> 'filled',
						esc_html__( 'Borderless', 'bambino' ) 	=> 'borderless',
						esc_html__( 'Outline', 'bambino' ) 		=> 'outline'
					)
				),
				array( 'param_name' => 'icons_color_scheme', 'type' => 'dropdown', 'heading' => esc_html__( 'Icons color scheme', 'bambino' ), 'description' => esc_html__( 'Define color schemes in Bold Builder settings or define accent and alternate colors in theme customizer (if avaliable)', 'bambino' ), 'value' => $color_scheme_arr ),
				array( 'param_name' => 'closed', 'type' => 'checkbox', 'value' => array( esc_html__( 'Yes', 'bambino' ) => 'closed' ), 'heading' => esc_html__( 'All items closed initially', 'bambino' ), 'preview' => true )
			)
		) );
	}
}