<?php

class bt_bb_custom_menu extends BT_BB_Element {

	function handle_shortcode( $atts, $content ) {
		extract( shortcode_atts( apply_filters( 'bt_bb_extract_atts_' . $this->shortcode, array(
			'menu'  			=> '',
			'font_weight'   	=> '',
			'font_size'   		=> '',
			'direction'  		=> 'vertical',

			'font'				=> '',
			'font_subset'   	=> ''
		) ), $atts, $this->shortcode ) );

		if ( $font != '' && $font != 'inherit' ) {
			require_once( WP_PLUGIN_DIR   .  '/bold-page-builder/content_elements_misc/misc.php' );
			bt_bb_enqueue_google_font( $font, $font_subset );
		}
		
		$class = array( $this->shortcode );
		
		if ( $el_class != '' ) {
			$class[] = $el_class;
		}
		
		if ( $direction != '' ) {
			$class[] = $this->prefix . 'direction' . '_' . $direction;
		}
		
		if ( $font != '' && $font != 'inherit' ) {
			$el_style .= 'font-family:\'' . urldecode_deep( $font ) . '\';';
		}

		if ( $font_weight != '' ) {
			$class[] = $this->prefix . 'font_weight' . '_' . $font_weight ;
		}

		if ( $font_size != '' ) {
			$class[] = $this->prefix . 'font_size' . '_' . $font_size ;
		}
		
		$id_attr = '';
		if ( $el_id != '' ) {
			$id_attr = ' ' . 'id="' . esc_attr( $el_id ) . '"';
		}

		$style_attr = '';
		if ( $el_style != '' ) {
			$style_attr = ' ' . 'style="' . esc_attr( $el_style ) . '"';
		}
		
		$output = wp_nav_menu( 
			array( 
				'menu' => $menu, 
				'echo' => false
			) 
		);
		
		$class = apply_filters( $this->shortcode . '_class', $class, $atts );
		
		$output = '<div' . $id_attr . ' class="' . implode( ' ', $class ) . '"' . $style_attr . '>' . $output . '</div>';
		
		$output = apply_filters( 'bt_bb_general_output', $output, $atts );
		$output = apply_filters( $this->shortcode . '_output', $output, $atts );
		
		return $output;

	}

	function map_shortcode() {

		include( WP_PLUGIN_DIR   . '/bold-page-builder/content_elements_misc/fonts.php' );

		$menus = wp_get_nav_menus();
		$nav_menu_arr = array();
		foreach( $menus as $menu ) {
			$nav_menu_arr[ $menu->name ] = $menu->slug;
		}
		bt_bb_map( $this->shortcode, array( 'name' => esc_html__( 'Custom Menu', 'bambino' ), 'description' => esc_html__( 'Custom WordPress menu', 'bambino' ), 'icon' => $this->prefix_backend . 'icon' . '_' . $this->shortcode,
			'params' => array(
				array( 'param_name' => 'menu', 'type' => 'dropdown', 'heading' => esc_html__( 'Menu name', 'bambino' ), 'preview' => true, 'value' => $nav_menu_arr ),
				array( 'param_name' => 'font_weight', 'type' => 'dropdown', 'heading' => esc_html__( 'Font weight', 'bambino' ),
					'value' => array(
						esc_html__( 'Default', 'bambino' ) 		=> '',
						esc_html__( 'Normal', 'bambino' ) 		=> 'normal',
						esc_html__( 'Bold', 'bambino' ) 		=> 'bold',
						esc_html__( 'Bolder', 'bambino' ) 		=> 'bolder',
						esc_html__( 'Lighter', 'bambino' ) 		=> 'lighter',
						esc_html__( 'Light', 'bambino' ) 		=> 'light',
						esc_html__( 'Thin', 'bambino' ) 		=> 'thin',
						esc_html__( '100', 'bambino' ) 			=> '100',
						esc_html__( '200', 'bambino' ) 			=> '200',
						esc_html__( '300', 'bambino' ) 			=> '300',
						esc_html__( '400', 'bambino' ) 			=> '400',
						esc_html__( '500', 'bambino' ) 			=> '500',
						esc_html__( '600', 'bambino' ) 			=> '600',
						esc_html__( '700', 'bambino' ) 			=> '700',
						esc_html__( '800', 'bambino' ) 			=> '800',
						esc_html__( '900', 'bambino' ) 			=> '900'
					)
				),
				array( 'param_name' => 'font_size', 'type' => 'dropdown', 'heading' => esc_html__( 'Font size', 'bambino' ),
					'value' => array(
						esc_html__( 'Default', 'bambino' ) 				=> '',
						esc_html__( '12px', 'bambino' ) 				=> '12',
						esc_html__( '13px', 'bambino' ) 				=> '13',
						esc_html__( '14px', 'bambino' ) 				=> '14',
						esc_html__( '15px', 'bambino' ) 				=> '15',
						esc_html__( '16px', 'bambino' ) 				=> '16',
						esc_html__( '17px', 'bambino' ) 				=> '17',
						esc_html__( '18px', 'bambino' ) 				=> '18'
					)
				),
				array( 'param_name' => 'direction', 'type' => 'dropdown', 'default' => 'vertical', 'heading' => esc_html__( 'Direction', 'bambino' ), 'preview' => true,
					'value' => array(
						esc_html__( 'Vertical', 'bambino' )     	=> 'vertical',
						esc_html__( 'Horizontal', 'bambino' )  		=> 'horizontal'					
					)
				),

				array( 'param_name' => 'font', 'type' => 'dropdown', 'heading' => esc_html__( 'Font', 'bambino' ), 'group' => esc_html__( 'Font', 'bambino' ), 'preview' => true,
					'value' => array( esc_html__( 'Inherit', 'bambino' ) => 'inherit' ) + BT_BB_Root::$font_arr
				),
				array( 'param_name' => 'font_subset', 'type' => 'textfield', 'heading' => esc_html__( 'Google Font subset', 'bambino' ), 'group' => esc_html__( 'Font', 'bambino' ), 'value' => 'latin,latin-ext', 'description' => esc_html__( 'E.g. latin,latin-ext,cyrillic,cyrillic-ext', 'bambino' ) ),
			)
		) );
	}
}