<?php

class bt_bb_icon extends BT_BB_Element {

	function handle_shortcode( $atts, $content ) {
		extract( shortcode_atts( apply_filters( 'bt_bb_extract_atts_' . $this->shortcode, array(
			'icon'         					=> '',
			'text'         					=> '',
			'url'          					=> '',
			'url_title'    					=> '',
			'target'       					=> '',
			'color_scheme' 					=> '',
			'style'        					=> '',
			'size'         					=> '',
			'shape'        					=> '',
			'align'        					=> 'inherit',
			'colored_icon'         			=> 'no_icon',
			'colored_icon_color_scheme' 	=> '',
			'title_weight' 					=> '',
			'title_size' 					=> '',
			'text_color_scheme' 			=> '',
			'semitransparent_text'         	=> '',
			'align_content'        			=> ''
		) ), $atts, $this->shortcode ) );

		$class = array( $this->shortcode );
		$data_override_class = array();

		if ( $el_class != '' ) {
			$class[] = $el_class;
		}

		$id_attr = '';
		if ( $el_id != '' ) {
			$id_attr = ' ' . 'id="' . esc_attr( $el_id ) . '"';
		}


		$color_scheme_id = NULL;
		if ( is_numeric ( $color_scheme ) ) {
			$color_scheme_id = $color_scheme;
		} else if ( $color_scheme != '' ) {
			$color_scheme_id = bt_bb_get_color_scheme_id( $color_scheme );
		}
		$color_scheme_colors = bt_bb_get_color_scheme_colors_by_id( $color_scheme_id - 1 );
		if ( $color_scheme_colors ) $el_style .= '; --primary-color:' . $color_scheme_colors[0] . '; --secondary-color:' . $color_scheme_colors[1] . ';';
		if ( $color_scheme != '' ) $class[] = $this->prefix . 'color_scheme_' .  $color_scheme_id;


		$text_color_scheme_id = NULL;
		if ( is_numeric ( $text_color_scheme ) ) {
			$text_color_scheme_id = $text_color_scheme;
		} else if ( $text_color_scheme != '' ) {
			$text_color_scheme_id = bt_bb_get_color_scheme_id( $text_color_scheme );
		}
		$text_color_scheme_colors = bt_bb_get_color_scheme_colors_by_id( $text_color_scheme_id - 1 );
		if ( $text_color_scheme_colors ) $el_style .= '; --text-primary-color:' . $text_color_scheme_colors[0] . '; --text-secondary-color:' . $text_color_scheme_colors[1] . ';';
		if ( $text_color_scheme != '' ) $class[] = $this->prefix . 'text_color_scheme_' .  $text_color_scheme_id;


		if ( $style != '' ) {
			$class[] = $this->prefix . 'style' . '_' . $style;
		}

		if ( $semitransparent_text != '' ) {
			$class[] = ' bt_bb_semitransparent_text';
		}

		$this->responsive_data_override_class(
			$class, $data_override_class,
			array(
				'prefix' => $this->prefix,
				'param' => 'align_content',
				'value' => $align_content
			)
		);

		$this->responsive_data_override_class(
			$class, $data_override_class,
			array(
				'prefix' => $this->prefix,
				'param' => 'size',
				'value' => $size
			)
		);

		if ( $shape != '' ) {
			$class[] = $this->prefix . 'shape' . '_' . $shape;
		}
		
		$this->responsive_data_override_class(
			$class, $data_override_class,
			array(
				'prefix' => $this->prefix,
				'param' => 'align',
				'value' => $align
			)
		);

		$colored_icon_color_scheme_id = NULL;
		if ( is_numeric ( $colored_icon_color_scheme ) ) {
			$colored_icon_color_scheme_id = $colored_icon_color_scheme;
		} else if ( $colored_icon_color_scheme != '' ) {
			$colored_icon_color_scheme_id = bt_bb_get_color_scheme_id( $colored_icon_color_scheme );
		}
		$colored_icon_color_scheme_colors = bt_bb_get_color_scheme_colors_by_id( $colored_icon_color_scheme_id - 1 );
		if ( $colored_icon_color_scheme_colors ) $el_style .= '; --icon-colored-icon-primary-color:' . $colored_icon_color_scheme_colors[0] . '; --icon-colored-icon-secondary-color:' . $colored_icon_color_scheme_colors[1] . ';';
		if ( $colored_icon_color_scheme != '' ) $class[] = $this->prefix . 'colored_icon_color_scheme_' .  $colored_icon_color_scheme_id;


		if ( $title_size != '' ) {
			$class[] = $this->prefix . 'title_size' . '_' . $title_size;
		}

		if ( $title_weight != '' ) {
			$class[] = $this->prefix . 'title_weight' . '_' . $title_weight;
		}

		$style_attr = '';
		if ( $el_style != '' ) {
			$style_attr = ' ' . 'style="' . esc_attr( $el_style ) . '"';
		}
		
		$class = apply_filters( $this->shortcode . '_class', $class, $atts );

		if ( $colored_icon == 'no_icon' || $colored_icon == '' ) {
			$output = $this->get_html( $icon, $text, $url, $url_title, $target );
		} else {
			$output = '';
			if ( $text != '' ) {
				if ( $url_title == '' ) $url_title = strip_tags( $text );
				$text = '<span class="bt_bb_icon_holder_text">' . $text . '</span>';
			}
			$link = bt_bb_get_url( $url );			
			if ( $link != '' ) {
				$output .= '<a href="' . esc_url( $link ) . '" target="' . esc_attr( $target ) . '" class="bt_bb_icon_holder" title="' . esc_attr( $url_title ) . '">';
					$output .= '<span class="bt_bb_icon_holder_inner">' . bt_bb_get_svg_icon_html( $colored_icon ) . '</span>';
					$output .= $text;
				$output .= '</a>';
			} else {
				$output .= '<span class="bt_bb_icon_holder">';
					$output .= '<span class="bt_bb_icon_holder_inner">' . bt_bb_get_svg_icon_html( $colored_icon ) . '</span>';
					$output .= $text;
				$output .= '</span>';
			}
		}
		
		$output = '<div' . $id_attr . ' class="' . implode( ' ', $class ) . '"' . $style_attr . ' data-bt-override-class="' . htmlspecialchars( json_encode( $data_override_class, JSON_FORCE_OBJECT ), ENT_QUOTES, 'UTF-8' ) . '">' . $output . '</div>';
		
		$output = apply_filters( 'bt_bb_general_output', $output, $atts );
		$output = apply_filters( $this->shortcode . '_output', $output, $atts );

		return $output;

	}

	static function get_html( $icon, $text = '', $url = '', $url_title = '', $target = '' ) {

		$icon_set = substr( $icon, 0, -5 );
		$icon = substr( $icon, -4 );

		$link = bt_bb_get_url( $url );

		if ( $text != '' ) {
			if ( $url_title == '' ) $url_title = strip_tags($text);
			$text = '<span>' . $text . '</span>';
		}
		
		$url_title_attr = '';
		
		if ( $url_title != '' ) {
			$url_title_attr = ' title="' . esc_attr( $url_title ) . '"';
		}
		
		if ( $link == '' ) {
			$ico_tag = 'span' . ' ';
			$ico_tag_end = 'span';	
		} else {
			$target_attr = 'target="_self"';
			if ( $target != '' ) {
				$target_attr = ' ' . 'target="' . ( $target ) . '"';
			}
			$ico_tag = 'a href="' . esc_attr( $link ) . '"' . ' ' . $target_attr . ' ' . $url_title_attr . ' ';
			$ico_tag_end = 'a';
		}

		return '<' . $ico_tag . ' data-ico-' . esc_attr( $icon_set ) . '="&#x' . esc_attr( $icon ) . ';" class="bt_bb_icon_holder">' . $text . '</' . $ico_tag_end . '>';
	}

	function map_shortcode() {

		$color_scheme_arr = bt_bb_get_color_scheme_param_array();
		$svg_icons_arr = bt_bb_get_svg_icons_param_array();

		bt_bb_map( $this->shortcode, array( 'name' => esc_html__( 'Icon', 'bambino' ), 'description' => esc_html__( 'Single icon with link', 'bambino' ), 'icon' => $this->prefix_backend . 'icon' . '_' . $this->shortcode,
			'params' => array(
				array( 'param_name' => 'icon', 'type' => 'iconpicker', 'heading' => esc_html__( 'Icon', 'bambino' ), 'preview' => true ),
				array( 'param_name' => 'colored_icon', 'type' => 'dropdown', 'default' => 'no_icon', 'heading' => esc_html__( 'Colored Icon', 'bambino' ), 'description' => __( 'If colored icon is chosen from the list, regular icon will not be displayed. View all colored icons <a href="https://bold-themes.com/wp-content/uploads/bambino_colored_icons/demo.html" target="_blank">here</a>', 'bambino' ), 'value' => $svg_icons_arr ),
				array( 'param_name' => 'text', 'type' => 'textfield', 'heading' => esc_html__( 'Text', 'bambino' ) ),
				
				array( 'param_name' => 'url', 'type' => 'link', 'group' => esc_html__( 'URL', 'bambino' ), 'heading' => esc_html__( 'URL', 'bambino' ), 'description' => esc_html__( 'Enter full or local URL (e.g. https://www.bold-themes.com or /pages/about-us) or post slug (e.g. about-us) or search for existing content.', 'bambino' ) ),
				array( 'param_name' => 'url_title', 'group' => esc_html__( 'URL', 'bambino' ), 'type' => 'textfield', 'heading' => esc_html__( 'Mouse hover title', 'bambino' ) ),
				array( 'param_name' => 'target', 'type' => 'dropdown', 'group' => esc_html__( 'URL', 'bambino' ), 'heading' => esc_html__( 'Target', 'bambino' ),
					'value' => array(
						esc_html__( 'Self (open in same tab)', 'bambino' ) 	=> '_self',
						esc_html__( 'Blank (open in new tab)', 'bambino' ) 	=> '_blank',
					)
				),

				array( 'param_name' => 'align', 'type' => 'dropdown', 'heading' => esc_html__( 'Alignment', 'bambino' ), 'description' => esc_html__( 'Please note that it is not possible to show multiple icons inline if any of them are using Center option.', 'bambino' ), 'responsive_override' => true,
					'value' => array(
						esc_html__( 'Inherit', 'bambino' ) 		=> 'inherit',
						esc_html__( 'Left', 'bambino' ) 		=> 'left',
						esc_html__( 'Center', 'bambino' ) 		=> 'center',
						esc_html__( 'Right', 'bambino' ) 		=> 'right'
					)
				),
				array( 'param_name' => 'size', 'type' => 'dropdown', 'default' => 'small', 'heading' => esc_html__( 'Icon size', 'bambino' ), 'preview' => true, 'group' => esc_html__( 'Design', 'bambino' ), 'responsive_override' => true,
					'value' => array(
						esc_html__( 'Extra small', 'bambino' ) 			=> 'xsmall',
						esc_html__( 'Small', 'bambino' ) 				=> 'small',
						esc_html__( 'Normal', 'bambino' ) 				=> 'normal',
						esc_html__( 'Large', 'bambino' ) 				=> 'large',
						esc_html__( 'Extra large', 'bambino' ) 			=> 'xlarge'
					)
				),
				array( 'param_name' => 'style', 'type' => 'dropdown', 'heading' => esc_html__( 'Icon style', 'bambino' ), 'preview' => true, 'group' => esc_html__( 'Design', 'bambino' ),
					'value' => array(
						esc_html__( 'Outline', 'bambino' ) 							=> 'outline',
						esc_html__( 'Filled', 'bambino' ) 							=> 'filled',
						esc_html__( 'Gradient filled (light font)', 'bambino' ) 	=> 'gradient_filled',
						esc_html__( 'Borderless', 'bambino' ) 						=> 'borderless'
					)
				),
				array( 'param_name' => 'shape', 'type' => 'dropdown', 'heading' => esc_html__( 'Icon shape', 'bambino' ), 'group' => esc_html__( 'Design', 'bambino' ),
					'value' => array(
						esc_html__( 'Circle', 'bambino' ) 				=> 'circle',
						esc_html__( 'Square', 'bambino' ) 				=> 'square',
						esc_html__( 'Rounded Square', 'bambino' ) 		=> 'round'
					)
				),
				array( 'param_name' => 'title_size', 'type' => 'dropdown', 'default' => '', 'heading' => esc_html__( 'Text size', 'bambino' ), 'preview' => true, 'group' => esc_html__( 'Design', 'bambino' ),
					'value' => array(
						esc_html__( 'Inherit', 'bambino' ) 				=> '',
						esc_html__( 'Extra small', 'bambino' ) 			=> 'xsmall',
						esc_html__( 'Small', 'bambino' ) 				=> 'small',
						esc_html__( 'Normal', 'bambino' ) 				=> 'normal',
						esc_html__( 'Large', 'bambino' ) 				=> 'large',
						esc_html__( 'Extra large', 'bambino' ) 			=> 'xlarge',
						esc_html__( 'Huge', 'bambino' ) 				=> 'huge'
					)
				),
				array( 'param_name' => 'title_weight', 'type' => 'dropdown', 'preview' => true, 'heading' => esc_html__( 'Text weight', 'bambino' ), 'group' => esc_html__( 'Design', 'bambino' ), 
					'value' => array(
						esc_html__( 'Default', 'bambino' ) 		=> '',
						esc_html__( 'Normal', 'bambino' ) 		=> 'normal',
						esc_html__( 'Bold', 'bambino' ) 		=> 'bold',
						esc_html__( 'Bolder', 'bambino' ) 		=> 'bolder',
						esc_html__( 'Lighter', 'bambino' ) 		=> 'lighter',
						esc_html__( 'Light', 'bambino' ) 		=> 'light',
						esc_html__( 'Thin', 'bambino' ) 		=> 'thin',
						esc_html__( '100', 'bambino' ) 			=> '100',
						esc_html__( '200', 'bambino' ) 			=> '200',
						esc_html__( '300', 'bambino' ) 			=> '300',
						esc_html__( '400', 'bambino' ) 			=> '400',
						esc_html__( '500', 'bambino' ) 			=> '500',
						esc_html__( '600', 'bambino' ) 			=> '600',
						esc_html__( '700', 'bambino' ) 			=> '700',
						esc_html__( '800', 'bambino' ) 			=> '800',
						esc_html__( '900', 'bambino' ) 			=> '900'
					)
				),
				array( 'param_name' => 'color_scheme', 'type' => 'dropdown', 'heading' => esc_html__( 'Color scheme', 'bambino' ), 'value' => $color_scheme_arr, 'preview' => true, 'group' => esc_html__( 'Design', 'bambino' ) ),
				array( 'param_name' => 'colored_icon_color_scheme', 'type' => 'dropdown', 'heading' => esc_html__( 'Colored icon color scheme', 'bambino' ), 'value' => $color_scheme_arr, 'group' => esc_html__( 'Design', 'bambino' ) ),
				array( 'param_name' => 'text_color_scheme', 'type' => 'dropdown', 'heading' => esc_html__( 'Text color scheme', 'bambino' ), 'value' => $color_scheme_arr, 'preview' => true, 'group' => esc_html__( 'Design', 'bambino' ) ),
				array( 'param_name' => 'semitransparent_text', 'type' => 'checkbox', 'value' => array( esc_html__( 'Yes', 'bambino' ) => 'true' ), 'heading' => esc_html__( 'Semitransparent text', 'bambino' ), 'group' => esc_html__( 'Design', 'bambino' ),
				),
				array( 'param_name' => 'align_content', 'type' => 'dropdown', 'default' => 'center', 'heading' => esc_html__( 'Content alignment', 'bambino' ), 'responsive_override' => true, 
					'value' => array(
						esc_html__( 'Top', 'bambino' ) 				=> 'top',
						esc_html__( 'Center', 'bambino' ) 			=> 'center',
						esc_html__( 'Bottom', 'bambino' ) 			=> 'bottom'
					)
				),
			)
		) );
	}
}