<?php

class bt_bb_promo extends BT_BB_Element {

	function handle_shortcode( $atts, $content ) {
		
		extract( shortcode_atts( apply_filters( 'bt_bb_extract_atts_' . $this->shortcode, array(
			'old_price'				=> '',
			'old_price_currency'	=> '',
			'new_price'				=> '',
			'new_price_currency'	=> '',
			'description'			=> '',			
			'currency_position'		=> ''
		) ), $atts, $this->shortcode ) );
		
		$class = array();
		
		$class[] = 'bt_bb_promo';

		$id_attr = '';
		if ( $el_id != '' ) {
			$id_attr = ' ' . 'id="' . esc_attr( $el_id ) . '"';
		}

		$style_attr = '';
		if ( $el_style != '' ) {
			$style_attr = ' ' . 'style="' . esc_attr( $el_style ) . '"';
		}
		
		$class = apply_filters( $this->shortcode . '_class', $class, $atts );
		$class_attr = implode( ' ', $class );
		
		if ( $el_class != '' ) {
			$class_attr = $class_attr . ' ' . $el_class;
		}

	
		$output = '';

		$output .= '<div' . $id_attr . ' class="' . esc_attr( $class_attr ) . '"' . $style_attr . '>';

			// OLD PRICE
			if ( $old_price != '' ) {
				if ( $currency_position == '' ) {
					$output .= '<span class="' . esc_attr( $this->shortcode . '_old_price_currency' ) . '">' . esc_attr( $old_price_currency ) . '</span><span class="' . esc_attr( $this->shortcode . '_old_price' ) . '">' . esc_attr( $old_price ) . '</span>';
				} else if ( $currency_position == 'right' ) {
					$output .= '<span class="' . esc_attr( $this->shortcode . '_old_price' ) . '">' . esc_attr( $old_price ) . '</span><span class="' . esc_attr( $this->shortcode . '_old_price_currency' ) . '">' . esc_attr( $old_price_currency ) . '</span>';
				}
			}

			// NEW PRICE
			if ( $new_price != '' ) {
				if ( $currency_position == '' ) {
					$output .= '<span class="' . esc_attr( $this->shortcode . '_new_price_currency' ) . '">' . esc_attr( $new_price_currency ) . '</span><span class="' . esc_attr( $this->shortcode . '_new_price' ) . '">' . esc_attr( $new_price ) . '</span>';
				} else {
					$output .= '<span class="' . esc_attr( $this->shortcode . '_new_price' ) . '">' . esc_attr( $new_price ) . '</span><span class="' . esc_attr( $this->shortcode . '_new_price_currency' ) . '">' . esc_attr( $new_price_currency ) . '</span>';
				}
			}

			// DESCRIPTION
			if ( $description != '' ) {
				$output .= '<span class="' . esc_attr( $this->shortcode . '_description' ) . '">' . esc_attr( $description ) . '</span>';
			}


		$output .= '</div>';
		
		$output = apply_filters( 'bt_bb_general_output', $output, $atts );
		$output = apply_filters( $this->shortcode . '_output', $output, $atts );
			
		return $output;
	}

	function map_shortcode() {

		bt_bb_map( $this->shortcode, array( 'name' => esc_html__( 'Promo', 'bambino' ), 'description' => esc_html__( 'Promo with new and old price', 'bambino' ),  
			'icon' => $this->prefix_backend . 'icon' . '_' . $this->shortcode,
			'params' => array(
				array( 'param_name' => 'old_price', 'type' => 'textfield', 'heading' => esc_html__( 'Old price', 'bambino' ) ),
				array( 'param_name' => 'old_price_currency', 'type' => 'textfield', 'heading' => esc_html__( 'Old price currency', 'bambino' ) ),
				array( 'param_name' => 'new_price', 'type' => 'textfield', 'heading' => esc_html__( 'New price', 'bambino' ), 'preview' => true ),
				array( 'param_name' => 'new_price_currency', 'type' => 'textfield', 'heading' => esc_html__( 'New price currency', 'bambino' ) ),
				array( 'param_name' => 'description', 'type' => 'textfield', 'heading' => esc_html__( 'Description', 'bambino' ) ),
				array( 'param_name' => 'currency_position', 'type' => 'dropdown', 'heading' => esc_html__( 'Currency position', 'bambino' ), 
					'value' => array(
						esc_html__( 'Left', 'bambino' ) 		=> '',
						esc_html__( 'Right', 'bambino' ) 		=> 'right'
					)
				)
			)
		) );
	}
}