<?php

class bt_bb_service extends BT_BB_Element {

	function handle_shortcode( $atts, $content ) {
		extract( shortcode_atts( apply_filters( 'bt_bb_extract_atts_' . $this->shortcode, array(
			'ai_prompt'    					=> '',
			'icon'         					=> '',
			'title'        					=> '',
			'html_tag'     					=> 'div',
			'text'         					=> '',
			'url'          					=> '',
			'target'       					=> '',
			'color_scheme' 					=> '',
			'style'        					=> '',
			'size'         					=> '',
			'shape'        					=> '',
			'align'        					=> '',
			'colored_icon'         			=> 'no_icon',
			'colored_icon_color_scheme' 	=> '',
			'title_color_scheme' 			=> '',
			'title_size'         			=> '',
			'title_weight'      			=> '',
			'border'         				=> '',
			'semitransparent_text'         	=> '',
			'align_content'        			=> '',
			'supertitle'        			=> '',
			'font'							=> '',
			'font_subset'					=> ''
		) ), $atts, $this->shortcode ) );

		$class = array( $this->shortcode );
		$data_override_class = array();

		if ( $font != '' && $font != 'inherit' ) {
			require_once( WP_PLUGIN_DIR   . '/bold-page-builder/content_elements_misc/misc.php' );
			bt_bb_enqueue_google_font( $font, $font_subset );
		}

		$title_font_style = "";
		if ( $font != '' && $font != 'inherit' ) {
			$title_font_style = ' style="font-family:\'' . urldecode( $font ) . '\';"';
		}

		if ( $el_class != '' ) {
			$class[] = $el_class;
		}

		$id_attr = '';
		if ( $el_id != '' ) {
			$id_attr = ' ' . 'id="' . esc_attr( $el_id ) . '"';
		}

		

		$color_scheme_id = NULL;
		if ( is_numeric ( $color_scheme ) ) {
			$color_scheme_id = $color_scheme;
		} else if ( $color_scheme != '' ) {
			$color_scheme_id = bt_bb_get_color_scheme_id( $color_scheme );
		}
		$color_scheme_colors = bt_bb_get_color_scheme_colors_by_id( $color_scheme_id - 1 );
		if ( $color_scheme_colors ) $el_style .= '; --primary-color:' . $color_scheme_colors[0] . '; --secondary-color:' . $color_scheme_colors[1] . ';';
		if ( $color_scheme != '' ) $class[] = $this->prefix . 'color_scheme_' .  $color_scheme_id;



		if ( $style != '' ) {
			$class[] = $this->prefix . 'style' . '_' . $style;
		}

		if ( $url != '' ) {
			$class[] = 'btWithLink';
		}

		if ( $semitransparent_text != '' ) {
			$class[] = ' bt_bb_semitransparent_text';
		}

		$this->responsive_data_override_class(
			$class, $data_override_class,
			array(
				'prefix' => $this->prefix,
				'param' => 'size',
				'value' => $size
			)
		);

		if ( $shape != '' ) {
			$class[] = $this->prefix . 'shape' . '_' . $shape;
		}

		if ( $align_content != '' ) {
			$class[] = $this->prefix . 'align_content' . '_' . $align_content;
		}

		$this->responsive_data_override_class(
			$class, $data_override_class,
			array(
				'prefix' => $this->prefix,
				'param' => 'align',
				'value' => $align
			)
		);

		if ( $supertitle == '' ) {
			$class[] = 'btNoSupertitle';
		}

		if ( $text == '' ) {
			$class[] = 'btNoText';
		}

		if ( $title == '' ) {
			$class[] = 'btNoTitle';
		}

		if ( $title_size != '' ) {
			$class[] = $this->prefix . 'title_size' . '_' . $title_size;
		}

		if ( $border != '' ) {
			$class[] = $this->prefix . 'border' . '_' . $border;
		}

		if ( $title_weight != '' ) {
			$class[] = $this->prefix . 'title_weight' . '_' . $title_weight;
		}
		

		$colored_icon_color_scheme_id = NULL;
		if ( is_numeric ( $colored_icon_color_scheme ) ) {
			$colored_icon_color_scheme_id = $colored_icon_color_scheme;
		} else if ( $colored_icon_color_scheme != '' ) {
			$colored_icon_color_scheme_id = bt_bb_get_color_scheme_id( $colored_icon_color_scheme );
		}
		$colored_icon_color_scheme_colors = bt_bb_get_color_scheme_colors_by_id( $colored_icon_color_scheme_id - 1 );
		if ( $colored_icon_color_scheme_colors ) $el_style .= '; --icon-colored-icon-primary-color:' . $colored_icon_color_scheme_colors[0] . '; --icon-colored-icon-secondary-color:' . $colored_icon_color_scheme_colors[1] . ';';
		if ( $colored_icon_color_scheme != '' ) $class[] = $this->prefix . 'colored_icon_color_scheme_' .  $colored_icon_color_scheme_id;



		$title_color_scheme_id = NULL;
		if ( is_numeric ( $title_color_scheme ) ) {
			$title_color_scheme_id = $title_color_scheme;
		} else if ( $title_color_scheme != '' ) {
			$title_color_scheme_id = bt_bb_get_color_scheme_id( $title_color_scheme );
		}
		$title_color_scheme_colors = bt_bb_get_color_scheme_colors_by_id( $title_color_scheme_id - 1 );
		if ( $title_color_scheme_colors ) $el_style .= '; --title-primary-color:' . $title_color_scheme_colors[0] . '; --title-secondary-color:' . $title_color_scheme_colors[1] . ';';
		if ( $title_color_scheme != '' ) $class[] = $this->prefix . 'title_color_scheme_' .  $title_color_scheme_id;

		

		$style_attr = '';
		if ( $el_style != '' ) {
			$style_attr = ' ' . 'style="' . esc_attr( $el_style ) . '"';
		}

		$class = apply_filters( $this->shortcode . '_class', $class, $atts );		
		$class_attr = implode( ' ', $class );

		if ( $el_class != '' ) {
			$class_attr = $class_attr . ' ' . $el_class;
		}
		

		$link = bt_bb_get_url( $url );

		if ( $link != '' ) {
			if ( $title != '' ) $title = '<a href="' . esc_url( $link ) . '" target="' . esc_attr( $target ) . '">' . $title . '</a>';
		}
		
		$icon_html = bt_bb_icon::get_html( $icon, '', $link, $target );

		// SERVICE
		$output = '<div' . $id_attr . ' class="' . esc_attr( implode( ' ', $class ) ) . '"' . $style_attr . ' data-bt-override-class="' . htmlspecialchars( json_encode( $data_override_class, JSON_FORCE_OBJECT ), ENT_QUOTES, 'UTF-8' ) . '">';

			// ICON
			if ( $icon != '' && $colored_icon == '' || $colored_icon == 'no_icon'  ) {
				$output .= $icon_html;
			}


			// COLORED ICON
			if ( $colored_icon != '' && $colored_icon != 'no_icon' ) {

				$output .= '<div class="' . esc_attr( $this->shortcode . '_colored_icon' ) . '">';
					
					if ( $link != '' ) {
						$output .= '<a href="' . esc_url( $link ) . '" target="' . esc_attr( $target ) . '">';
							$output .= bt_bb_get_svg_icon_html( $colored_icon );
						$output .= '</a>';

					} else {
						$output .= '<span>';
							$output .= bt_bb_get_svg_icon_html( $colored_icon );
						$output .= '</span>';
					}

				$output .= '</div>';
			}

			// CONTENT
			$output .= '<div class="' . esc_attr( $this->shortcode ) . '_content">';
				if ( $supertitle != '' ) $output .= '<div class="' . esc_attr( $this->shortcode ) . '_content_supertitle">' . $supertitle . '</div>';
				if ( $title != '' ) $output .= '<'. $html_tag . ' class="' . esc_attr( $this->shortcode ) . '_content_title" ' . $title_font_style . '>' . $title . '</'. $html_tag . '>';
				if ( $text != '' ) $output .= '<div class="' . esc_attr( $this->shortcode ) . '_content_text">' . nl2br( $text ) . '</div>';
			$output .= '</div>';


		$output .= '</div>';

		
		$output = apply_filters( 'bt_bb_general_output', $output, $atts );
		$output = apply_filters( $this->shortcode . '_output', $output, $atts );

		return $output;

	}

	function map_shortcode() {

		include( WP_PLUGIN_DIR   . '/bold-page-builder/content_elements_misc/fonts.php' );

		$color_scheme_arr = bt_bb_get_color_scheme_param_array();
		$svg_icons_arr = bt_bb_get_svg_icons_param_array();

		bt_bb_map( $this->shortcode, array( 'name' => esc_html__( 'Service', 'bambino' ), 'description' => esc_html__( 'Icon with text (and AI help)', 'bambino' ), 'icon' => $this->prefix_backend . 'icon' . '_' . $this->shortcode,
			'params' => array(
				array(
					'param_name' => 'ai_prompt',
					'type' => 'ai_prompt',
					'target' =>
						array(
							'title' => array( 'alias' => 'title', 'title' => esc_html__( 'Title', 'bambino' ) ),
							'text' => array( 'alias' => 'text', 'title' => esc_html__( 'Text', 'bambino' ) ),
							'supertitle' => array( 'alias' => 'supertitle', 'title' => esc_html__( 'Supertitle', 'bambino' ) ),
						),
					'system_prompt' => 'You are a copywriter and your GOAL is to help users generate website content. Based on the user prompt generate title and text for the website page.',
				),
				array( 'param_name' => 'icon', 'type' => 'iconpicker', 'heading' => esc_html__( 'Icon', 'bambino' ),  'description' => esc_html__( 'If colored icon is chosen from the list, regular icon will not be displayed', 'bambino' ), 'preview' => true ),
				array( 'param_name' => 'colored_icon', 'type' => 'dropdown', 'default' => 'no_icon', 'heading' => esc_html__( 'Colored Icon', 'bambino' ), 'description' => __( 'If colored icon is chosen from the list, regular icon will not be displayed. View all colored icons <a href="https://bold-themes.com/wp-content/uploads/bambino_colored_icons/demo.html" target="_blank">here</a>', 'bambino' ), 'value' => $svg_icons_arr ),
				array( 'param_name' => 'supertitle', 'type' => 'textfield', 'heading' => esc_html__( 'Supertitle', 'bambino' ) ),
				array( 'param_name' => 'title', 'type' => 'textfield', 'heading' => esc_html__( 'Title', 'bambino' ), 'preview' => true ),
				array( 'param_name' => 'html_tag', 'type' => 'dropdown', 'heading' => esc_html__( 'Title HTML tag', 'bambino' ), 'preview' => true, 'default' => 'div',
					'value' => array(
						esc_html__( 'div', 'bambino' ) => 'div',
						esc_html__( 'h1', 'bambino' ) 	=> 'h1',
						esc_html__( 'h2', 'bambino' ) 	=> 'h2',
						esc_html__( 'h3', 'bambino' ) 	=> 'h3',
						esc_html__( 'h4', 'bambino' ) 	=> 'h4',
						esc_html__( 'h5', 'bambino' ) 	=> 'h5',
						esc_html__( 'h6', 'bambino' ) 	=> 'h6'
				) ),
				array( 'param_name' => 'text', 'type' => 'textarea', 'heading' => esc_html__( 'Text', 'bambino' ) ),
				array( 'param_name' => 'align', 'type' => 'dropdown', 'heading' => esc_html__( 'Icon alignment', 'bambino' ), 'responsive_override' => true,
					'value' => array(
						esc_html__( 'Inherit', 'bambino' ) 			=> 'inherit',
						esc_html__( 'Left', 'bambino' ) 			=> 'left',
						esc_html__( 'Center', 'bambino' ) 			=> 'center',
						esc_html__( 'Right', 'bambino' ) 			=> 'right'
					)
				),
				array( 'param_name' => 'align_content', 'type' => 'dropdown', 'heading' => esc_html__( 'Content alignment', 'bambino' ), 
					'value' => array(
						esc_html__( 'Top', 'bambino' ) 				=> '',
						esc_html__( 'Center', 'bambino' ) 			=> 'center',
						esc_html__( 'Bottom', 'bambino' ) 			=> 'bottom'
					)
				),

				array( 'param_name' => 'size', 'type' => 'dropdown', 'heading' => esc_html__( 'Icon size', 'bambino' ), 'responsive_override' => true, 'preview' => true, 'group' => esc_html__( 'Design', 'bambino' ),
					'value' => array(
						esc_html__( 'Extra small', 'bambino' ) 		=> 'xsmall',
						esc_html__( 'Small', 'bambino' ) 			=> 'small',
						esc_html__( 'Medium', 'bambino' ) 			=> 'medium',
						esc_html__( 'Normal', 'bambino' ) 			=> 'normal',
						esc_html__( 'Large', 'bambino' ) 			=> 'large',
						esc_html__( 'Extra large', 'bambino' ) 		=> 'xlarge'
					)
				),
				array( 'param_name' => 'style', 'type' => 'dropdown', 'heading' => esc_html__( 'Icon style', 'bambino' ), 'preview' => true, 'group' => esc_html__( 'Design', 'bambino' ),
					'value' => array(
						esc_html__( 'Outline', 'bambino' ) 			=> 'outline',
						esc_html__( 'Filled', 'bambino' ) 			=> 'filled',
						esc_html__( 'Borderless', 'bambino' ) 		=> 'borderless'
					)
				),
				array( 'param_name' => 'shape', 'type' => 'dropdown', 'heading' => esc_html__( 'Icon shape', 'bambino' ), 'group' => esc_html__( 'Design', 'bambino' ),
					'value' => array(
						esc_html__( 'Circle', 'bambino' ) 			=> 'circle',
						esc_html__( 'Square', 'bambino' ) 			=> 'square',
						esc_html__( 'Rounded Square', 'bambino' ) 	=> 'round'
					)
				),
				array( 'param_name' => 'color_scheme', 'type' => 'dropdown', 'heading' => esc_html__( 'Icon color scheme', 'bambino' ), 'value' => $color_scheme_arr, 'preview' => true, 'group' => esc_html__( 'Design', 'bambino' ) ),
				array( 'param_name' => 'colored_icon_color_scheme', 'type' => 'dropdown', 'heading' => esc_html__( 'Colored icon color scheme', 'bambino' ), 'value' => $color_scheme_arr, 'group' => esc_html__( 'Design', 'bambino' ) ),
				array( 'param_name' => 'title_color_scheme', 'type' => 'dropdown', 'heading' => esc_html__( 'Title color scheme', 'bambino' ), 'value' => $color_scheme_arr, 'group' => esc_html__( 'Design', 'bambino' ) ),
				array( 'param_name' => 'title_size', 'type' => 'dropdown', 'default' => '', 'heading' => esc_html__( 'Title size', 'bambino' ), 'preview' => true, 'group' => esc_html__( 'Design', 'bambino' ),
					'value' => array(
						esc_html__( 'Inherit', 'bambino' ) 			=> '',
						esc_html__( 'Extra small', 'bambino' ) 		=> 'xsmall',
						esc_html__( 'Small', 'bambino' ) 			=> 'small',
						esc_html__( 'Medium', 'bambino' ) 			=> 'medium',
						esc_html__( 'Normal', 'bambino' ) 			=> 'normal',
						esc_html__( 'Large', 'bambino' ) 			=> 'large',
						esc_html__( 'Extra large', 'bambino' ) 		=> 'xlarge',
						esc_html__( 'Huge', 'bambino' ) 			=> 'huge'
					)
				),
				array( 'param_name' => 'title_weight', 'type' => 'dropdown', 'heading' => esc_html__( 'Title weight', 'bambino' ), 'group' => esc_html__( 'Design', 'bambino' ), 
					'value' => array(
						esc_html__( 'Default', 'bambino' ) 		=> '',
						esc_html__( 'Normal', 'bambino' ) 		=> 'normal',
						esc_html__( 'Bold', 'bambino' ) 		=> 'bold',
						esc_html__( 'Bolder', 'bambino' ) 		=> 'bolder',
						esc_html__( 'Lighter', 'bambino' ) 		=> 'lighter',
						esc_html__( 'Light', 'bambino' ) 		=> 'light',
						esc_html__( 'Thin', 'bambino' ) 		=> 'thin',
						esc_html__( '100', 'bambino' ) 			=> '100',
						esc_html__( '200', 'bambino' ) 			=> '200',
						esc_html__( '300', 'bambino' ) 			=> '300',
						esc_html__( '400', 'bambino' ) 			=> '400',
						esc_html__( '500', 'bambino' ) 			=> '500',
						esc_html__( '600', 'bambino' ) 			=> '600',
						esc_html__( '700', 'bambino' ) 			=> '700',
						esc_html__( '800', 'bambino' ) 			=> '800',
						esc_html__( '900', 'bambino' ) 			=> '900'
					)
				),
				array( 'param_name' => 'border', 'type' => 'dropdown', 'heading' => esc_html__( 'Border', 'bambino' ), 'group' => esc_html__( 'Design', 'bambino' ),
					'value' => array(
						esc_html__( 'No', 'bambino' ) 				=> '',
						esc_html__( 'Yes', 'bambino' ) 				=> 'visible'
					)
				),
				array( 'param_name' => 'semitransparent_text', 'type' => 'checkbox', 'value' => array( esc_html__( 'Yes', 'bambino' ) => 'true' ), 'heading' => esc_html__( 'Semitransparent text', 'bambino' ), 'group' => esc_html__( 'Design', 'bambino' ),
				),
				
				array( 'param_name' => 'url', 'type' => 'link', 'heading' => esc_html__( 'URL', 'bambino' ), 'group' => esc_html__( 'URL', 'bambino' ), 'description' => esc_html__( 'Enter full or local URL (e.g. https://www.bold-themes.com or /pages/about-us) or post slug (e.g. about-us) or search for existing content.', 'bambino' ) ),
				array( 'param_name' => 'target', 'type' => 'dropdown', 'heading' => esc_html__( 'Target', 'bambino' ), 'group' => esc_html__( 'URL', 'bambino' ),
					'value' => array(
						esc_html__( 'Self (open in same tab)', 'bambino' ) 	=> '_self',
						esc_html__( 'Blank (open in new tab)', 'bambino' ) 	=> '_blank',
					)
				),

				array( 'param_name' => 'font', 'type' => 'dropdown', 'heading' => esc_html__( 'Title Font', 'bambino' ), 'group' => esc_html__( 'Design', 'bambino' ), 'preview' => true, 'value' => array( esc_html__( 'Inherit', 'bambino' ) => 'inherit' ) + $font_arr
				),
				array( 'param_name' => 'font_subset', 'type' => 'textfield', 'heading' => esc_html__( 'Title Font subset', 'bambino' ), 'group' => esc_html__( 'Design', 'bambino' ), 'value' => 'latin,latin-ext', 'description' => esc_html__( 'E.g. latin,latin-ext,cyrillic,cyrillic-ext', 'bambino' ) ),
			)
		) );
	}
}