<?php

class bt_bb_working_hours_inner extends BT_BB_Element {

	function handle_shortcode( $atts, $content ) {
		extract( shortcode_atts( apply_filters( 'bt_bb_extract_atts', array(
			'day'						=> '',
			'time'						=> '',
			'selected_days'				=> ''
			
		) ), $atts, $this->shortcode ) );		

		$class = array( $this->shortcode );

		if ( $el_class != '' ) {
			$class[] = $el_class;
		}

		if ( $selected_days != '' ) {
			$selected_days_arr = preg_split( '/\s+/', $selected_days );
			if ( !empty( $selected_days_arr ) ) {
				if ( in_array( strtolower(date('D')), array_map('strtolower', $selected_days_arr) ) ){
					$class[] = 'btCurrrentDay';
				}
			}
		}

		$id_attr = '';
		if ( $el_id != '' ) {
			$id_attr = ' ' . 'id="' . esc_attr( $el_id ) . '"';
		}

		$class = apply_filters( $this->shortcode . '_class', $class, $atts );
		$class_attr = implode( ' ', $class );


		if ( $el_class != '' ) {
			$class_attr = $class_attr . ' ' . $el_class;
		}

		$style_attr = '';
		if ( $el_style != '' ) {
			$style_attr = ' ' . 'style="' . esc_attr( $el_style ) . '"';
		}

			
		$output = '<div' . $id_attr . ' class="' . esc_attr( $class_attr ) . '" ' . $style_attr . '>';

			if ( $day != '' ) $output .= '<div class="' . esc_attr( $this->shortcode . '_day' ) . '"><div class="' . esc_attr( $this->shortcode . '_day_value' ) . '">' . $day . '</div></div>';
			if ( $time != '' ) $output .= '<div class="' . esc_attr( $this->shortcode . '_time' ) . '"><div class="' . esc_attr( $this->shortcode . '_time_value' ) . '">' . $time . '</div></div>';

		$output .= '</div>';
		
		$output = apply_filters( 'bt_bb_general_output', $output, $atts );
		$output = apply_filters( $this->shortcode . '_output', $output, $atts );

		return $output;
	}	

	function map_shortcode() {

		$color_scheme_arr = bt_bb_get_color_scheme_param_array();

		bt_bb_map( $this->shortcode, array( 'name' => esc_html__( 'Working hour', 'bambino' ), 'description' => esc_html__( 'Working hour with day and time', 'bambino' ), 'as_child' => array( 'only' => 'bt_bb_working_hours' ), 'icon' => $this->prefix_backend . 'icon' . '_' . $this->shortcode,
			'params' => array(
				array( 'param_name' => 'day', 'type' => 'textfield', 'preview' => true, 'heading' => esc_html__( 'Day', 'bambino' ) ),
				array( 'param_name' => 'time', 'type' => 'textfield', 'heading' => esc_html__( 'Time', 'bambino' ) ),
				array( 'param_name' => 'selected_days', 'type' => 'checkbox_group', 'heading' => esc_html__( 'Selected days', 'bambino' ), 
					'value' => array(
						esc_html__( 'Monday', 'bambino' )		=> 'mon',
						esc_html__( 'Tuesday', 'bambino' )		=> 'tue',
						esc_html__( 'Wednesday', 'bambino' )	=> 'wed',
						esc_html__( 'Thursday', 'bambino' )		=> 'thu',
						esc_html__( 'Friday', 'bambino' )		=> 'fri',
						esc_html__( 'Saturday', 'bambino' )		=> 'sat',
						esc_html__( 'Sunday', 'bambino' )		=> 'sun',
					)
				)
			))
		);
	}
}