<?php

/* Remove unused params */
remove_action( 'customize_register', 'boldthemes_customize_blog_side_info' );
remove_action( 'boldthemes_customize_register', 'boldthemes_customize_blog_side_info' );



/* GENERAL SECTION 
-------------------------------------------------------------- */

// CUSTOM 404 IMAGE
if ( ! function_exists( 'boldthemes_customize_image_404' ) ) {
	function boldthemes_customize_image_404( $wp_customize ) {
		
		$wp_customize->add_setting( BoldThemesFramework::$pfx . '_theme_options[image_404]', array(
			'default'           => BoldThemes_Customize_Default::$data['image_404'],
			'type'              => 'option',
			'capability'        => 'edit_theme_options',
			'sanitize_callback' => 'boldthemes_sanitize_image'
		));
		$wp_customize->add_control( new WP_Customize_Image_Control( $wp_customize, 'image_404', array(
			'label'    => esc_html__( 'Custom Error 404 Page Image', 'bambino' ),
			'description'    => esc_html__( 'Set static image as a background on Error page. Minimum recommended size: 1920x1080px', 'bambino' ),
			'section'  => BoldThemesFramework::$pfx . '_general_section',
			'settings' => BoldThemesFramework::$pfx . '_theme_options[image_404]',
			'priority' => 121,
			'context'  => BoldThemesFramework::$pfx . '_image_404'
		)));
	}
}
add_action( 'customize_register', 'boldthemes_customize_image_404' );
add_action( 'boldthemes_customize_register', 'boldthemes_customize_image_404' );



// TEXT COLOR
BoldThemes_Customize_Default::$data['text_color'] = '';

if ( ! function_exists( 'boldthemes_customize_text_color' ) ) {
	function boldthemes_customize_text_color( $wp_customize ) {

		$wp_customize->add_setting( BoldThemesFramework::$pfx . '_theme_options[text_color]', array(
			'default'           => BoldThemes_Customize_Default::$data['text_color'],
			'type'              => 'option',
			'capability'        => 'edit_theme_options',
			'sanitize_callback' => 'boldthemes_sanitize_select'
		));
		$wp_customize->add_control( 'text_color', array(
			'label'     => esc_html__( 'Body text color', 'bambino' ),
			'section'   => BoldThemesFramework::$pfx . '_general_section',
			'settings'  => BoldThemesFramework::$pfx . '_theme_options[text_color]',
			'priority'  => 122,
			'type'      => 'select',
			'choices'   => array(
				''				=> esc_html__( 'Inherit from template skin', 'bambino' ),
				'darkgray' 		=> esc_html__( 'Dark gray color', 'bambino' )
			)
		));
	}
}
add_action( 'customize_register', 'boldthemes_customize_text_color' );
add_action( 'boldthemes_customize_register', 'boldthemes_customize_text_color' );



/* TYPO SECTION
-------------------------------------------------------------- */

// HEADING WEIGHT
BoldThemes_Customize_Default::$data['default_heading_weight'] = 'default';

if ( ! function_exists( 'boldthemes_customize_default_heading_weight' ) ) {
	function boldthemes_customize_default_heading_weight( $wp_customize ) {

		$wp_customize->add_setting( BoldThemesFramework::$pfx . '_theme_options[default_heading_weight]', array(
			'default'           => BoldThemes_Customize_Default::$data['default_heading_weight'],
			'type'              => 'option',
			'capability'        => 'edit_theme_options',
			'sanitize_callback' => 'boldthemes_sanitize_select'
		));
		$wp_customize->add_control( 'default_heading_weight', array(
			'label'     => esc_html__( 'Heading Font Weight', 'bambino' ),
			'section'   => BoldThemesFramework::$pfx . '_typo_section',
			'settings'  => BoldThemesFramework::$pfx . '_theme_options[default_heading_weight]',
			'priority'  => 101,
			'type'      => 'select',
			'choices'   => array(
				'default'		=> esc_html__( 'Default', 'bambino' ),
				'normal' 		=> esc_html__( 'Normal', 'bambino' ),
				'bold' 			=> esc_html__( 'Bold', 'bambino' ),
				'bolder' 		=> esc_html__( 'Bolder', 'bambino' ),
				'lighter' 		=> esc_html__( 'Lighter', 'bambino' ),
				'light' 		=> esc_html__( 'Light', 'bambino' ),
				'thin' 			=> esc_html__( 'Thin', 'bambino' ),
				'100' 			=> esc_html__( '100', 'bambino' ),
				'200' 			=> esc_html__( '200', 'bambino' ),
				'300' 			=> esc_html__( '300', 'bambino' ),
				'400' 			=> esc_html__( '400', 'bambino' ),
				'500' 			=> esc_html__( '500', 'bambino' ),
				'600' 			=> esc_html__( '600', 'bambino' ),
				'700' 			=> esc_html__( '700', 'bambino' ),
				'800' 			=> esc_html__( '800', 'bambino' ),
				'900' 			=> esc_html__( '900', 'bambino' )
			)
		));
	}
}
add_action( 'customize_register', 'boldthemes_customize_default_heading_weight' );
add_action( 'boldthemes_customize_register', 'boldthemes_customize_default_heading_weight' );


// SUPERTITLE WEIGHT
BoldThemes_Customize_Default::$data['default_supertitle_weight'] = 'default';
if ( ! function_exists( 'boldthemes_customize_default_supertitle_weight' ) ) {
	function boldthemes_customize_default_supertitle_weight( $wp_customize ) {

		$wp_customize->add_setting( BoldThemesFramework::$pfx . '_theme_options[default_supertitle_weight]', array(
			'default'           => BoldThemes_Customize_Default::$data['default_supertitle_weight'],
			'type'              => 'option',
			'capability'        => 'edit_theme_options',
			'sanitize_callback' => 'boldthemes_sanitize_select'
		));

		$wp_customize->add_control( 'default_supertitle_weight', array(
			'label'     		=> esc_html__( 'Supertitle Font Weight', 'bambino' ),
			'section'   		=> BoldThemesFramework::$pfx . '_typo_section',
			'settings'  		=> BoldThemesFramework::$pfx . '_theme_options[default_supertitle_weight]',
			'priority'  		=> 103,
			'type'      		=> 'select',
			'choices'   => array(
				'default'		=> esc_html__( 'Default', 'bambino' ),
				'normal' 		=> esc_html__( 'Normal', 'bambino' ),
				'bold' 			=> esc_html__( 'Bold', 'bambino' ),
				'bolder' 		=> esc_html__( 'Bolder', 'bambino' ),
				'lighter' 		=> esc_html__( 'Lighter', 'bambino' ),
				'light' 		=> esc_html__( 'Light', 'bambino' ),
				'thin' 			=> esc_html__( 'Thin', 'bambino' ),
				'100' 			=> esc_html__( '100', 'bambino' ),
				'200' 			=> esc_html__( '200', 'bambino' ),
				'300' 			=> esc_html__( '300', 'bambino' ),
				'400' 			=> esc_html__( '400', 'bambino' ),
				'500' 			=> esc_html__( '500', 'bambino' ),
				'600' 			=> esc_html__( '600', 'bambino' ),
				'700' 			=> esc_html__( '700', 'bambino' ),
				'800' 			=> esc_html__( '800', 'bambino' ),
				'900' 			=> esc_html__( '900', 'bambino' )
			)
		));
	}
}
add_action( 'customize_register', 'boldthemes_customize_default_supertitle_weight' );
add_action( 'boldthemes_customize_register', 'boldthemes_customize_default_supertitle_weight' );


// LETTER SPACING SUPERTITLE FONT
BoldThemes_Customize_Default::$data['letter_spacing_supertitle'] = '0.5';
if ( ! function_exists( 'boldthemes_customize_letter_spacing_supertitle' ) ) {
	function boldthemes_customize_letter_spacing_supertitle( $wp_customize ) {
		
		$wp_customize->add_setting( BoldThemesFramework::$pfx . '_theme_options[letter_spacing_supertitle]', array(
			'default'           => BoldThemes_Customize_Default::$data['letter_spacing_supertitle'],
			'type'              => 'option',
			'capability'        => 'edit_theme_options',
			'sanitize_callback' => 'sanitize_text_field'
		));

		$wp_customize->add_control( 'letter_spacing_supertitle', array(
			'label'     => esc_html__( 'Supertitle Font Letter spacing', 'bambino' ),
			'description'    => esc_html__( 'Enter number (without px) in order to define letter spacing in the supertitle (e.g. -1, 0, 1 etc.).', 'bambino' ),
			'section'  => BoldThemesFramework::$pfx . '_typo_section',
			'settings' => BoldThemesFramework::$pfx . '_theme_options[letter_spacing_supertitle]',
			'priority' => 104,
			'type'     => 'text'
		));
	}
}
add_action( 'customize_register', 'boldthemes_customize_letter_spacing_supertitle' );
add_action( 'boldthemes_customize_register', 'boldthemes_customize_letter_spacing_supertitle' );


// SUBTITLE WEIGHT
BoldThemes_Customize_Default::$data['default_subtitle_weight'] = 'default';
if ( ! function_exists( 'boldthemes_customize_default_subtitle_weight' ) ) {
	function boldthemes_customize_default_subtitle_weight( $wp_customize ) {

		$wp_customize->add_setting( BoldThemesFramework::$pfx . '_theme_options[default_subtitle_weight]', array(
			'default'           => BoldThemes_Customize_Default::$data['default_subtitle_weight'],
			'type'              => 'option',
			'capability'        => 'edit_theme_options',
			'sanitize_callback' => 'boldthemes_sanitize_select'
		));

		$wp_customize->add_control( 'default_subtitle_weight', array(
			'label'     		=> esc_html__( 'Subtitle Font Weight', 'bambino' ),
			'section'   		=> BoldThemesFramework::$pfx . '_typo_section',
			'settings'  		=> BoldThemesFramework::$pfx . '_theme_options[default_subtitle_weight]',
			'priority'  		=> 106,
			'type'      		=> 'select',
			'choices'   => array(
				'default'		=> esc_html__( 'Default', 'bambino' ),
				'normal' 		=> esc_html__( 'Normal', 'bambino' ),
				'bold' 			=> esc_html__( 'Bold', 'bambino' ),
				'bolder' 		=> esc_html__( 'Bolder', 'bambino' ),
				'lighter' 		=> esc_html__( 'Lighter', 'bambino' ),
				'light' 		=> esc_html__( 'Light', 'bambino' ),
				'thin' 			=> esc_html__( 'Thin', 'bambino' ),
				'100' 			=> esc_html__( '100', 'bambino' ),
				'200' 			=> esc_html__( '200', 'bambino' ),
				'300' 			=> esc_html__( '300', 'bambino' ),
				'400' 			=> esc_html__( '400', 'bambino' ),
				'500' 			=> esc_html__( '500', 'bambino' ),
				'600' 			=> esc_html__( '600', 'bambino' ),
				'700' 			=> esc_html__( '700', 'bambino' ),
				'800' 			=> esc_html__( '800', 'bambino' ),
				'900' 			=> esc_html__( '900', 'bambino' )
			)
		));
	}
}
add_action( 'customize_register', 'boldthemes_customize_default_subtitle_weight' );
add_action( 'boldthemes_customize_register', 'boldthemes_customize_default_subtitle_weight' );


// BUTTON FONT
if ( ! function_exists( 'boldthemes_customize_button_font' ) ) {
	function boldthemes_customize_button_font( $wp_customize ) {
		
		$wp_customize->add_setting( BoldThemesFramework::$pfx . '_theme_options[button_font]', array(
			'default'           => urlencode( BoldThemes_Customize_Default::$data['button_font'] ),
			'type'              => 'option',
			'capability'        => 'edit_theme_options',
			'sanitize_callback' => 'boldthemes_sanitize_select'
		));
		$wp_customize->add_control( 'button_font', array(
			'label'     => esc_html__( 'Button Font', 'bambino' ),
			'section'   => BoldThemesFramework::$pfx . '_typo_section',
			'settings'  => BoldThemesFramework::$pfx . '_theme_options[button_font]',
			'priority'  => 107,
			'type'      => 'select',
			'choices'   => BoldThemesFramework::$customize_fonts
		));
	}
}
add_action( 'customize_register', 'boldthemes_customize_button_font' );
add_action( 'boldthemes_customize_register', 'boldthemes_customize_button_font' );



// BUTTON FONT WEIGHT
BoldThemes_Customize_Default::$data['default_button_weight'] = 'default';
if ( ! function_exists( 'boldthemes_customize_default_button_weight' ) ) {
	function boldthemes_customize_default_button_weight( $wp_customize ) {

		$wp_customize->add_setting( BoldThemesFramework::$pfx . '_theme_options[default_button_weight]', array(
			'default'           => BoldThemes_Customize_Default::$data['default_button_weight'],
			'type'              => 'option',
			'capability'        => 'edit_theme_options',
			'sanitize_callback' => 'boldthemes_sanitize_select'
		));
		$wp_customize->add_control( 'default_button_weight', array(
			'label'     => esc_html__( 'Button Font Weight', 'bambino' ),
			'section'   => BoldThemesFramework::$pfx . '_typo_section',
			'settings'  => BoldThemesFramework::$pfx . '_theme_options[default_button_weight]',
			'priority'  => 108,
			'type'      => 'select',
			'choices'   => array(
				'default'		=> esc_html__( 'Default', 'bambino' ),
				'normal' 		=> esc_html__( 'Normal', 'bambino' ),
				'bold' 			=> esc_html__( 'Bold', 'bambino' ),
				'bolder' 		=> esc_html__( 'Bolder', 'bambino' ),
				'lighter' 		=> esc_html__( 'Lighter', 'bambino' ),
				'light' 		=> esc_html__( 'Light', 'bambino' ),
				'thin' 			=> esc_html__( 'Thin', 'bambino' ),
				'100' 			=> esc_html__( '100', 'bambino' ),
				'200' 			=> esc_html__( '200', 'bambino' ),
				'300' 			=> esc_html__( '300', 'bambino' ),
				'400' 			=> esc_html__( '400', 'bambino' ),
				'500' 			=> esc_html__( '500', 'bambino' ),
				'600' 			=> esc_html__( '600', 'bambino' ),
				'700' 			=> esc_html__( '700', 'bambino' ),
				'800' 			=> esc_html__( '800', 'bambino' ),
				'900' 			=> esc_html__( '900', 'bambino' )
			)
		));
	}
}
add_action( 'customize_register', 'boldthemes_customize_default_button_weight' );
add_action( 'boldthemes_customize_register', 'boldthemes_customize_default_button_weight' );


// LETTER SPACING BUTTON FONT
BoldThemes_Customize_Default::$data['letter_spacing_button'] = '0.5';
if ( ! function_exists( 'boldthemes_customize_letter_spacing_button' ) ) {
	function boldthemes_customize_letter_spacing_button( $wp_customize ) {
		
		$wp_customize->add_setting( BoldThemesFramework::$pfx . '_theme_options[letter_spacing_button]', array(
			'default'           => BoldThemes_Customize_Default::$data['letter_spacing_button'],
			'type'              => 'option',
			'capability'        => 'edit_theme_options',
			'sanitize_callback' => 'sanitize_text_field'
		));

		$wp_customize->add_control( 'letter_spacing_button', array(
			'label'     => esc_html__( 'Button Font Letter spacing', 'bambino' ),
			'description'    => esc_html__( 'Enter number (without px) in order to define letter spacing in the buttons (e.g. -1, 0, 1 etc.).', 'bambino' ),
			'section'  => BoldThemesFramework::$pfx . '_typo_section',
			'settings' => BoldThemesFramework::$pfx . '_theme_options[letter_spacing_button]',
			'priority' => 109,
			'type'     => 'text'
		));
	}
}
add_action( 'customize_register', 'boldthemes_customize_letter_spacing_button' );
add_action( 'boldthemes_customize_register', 'boldthemes_customize_letter_spacing_button' );



// MENU WEIGHT
BoldThemes_Customize_Default::$data['default_menu_weight'] = 'default';
if ( ! function_exists( 'boldthemes_customize_default_menu_weight' ) ) {
	function boldthemes_customize_default_menu_weight( $wp_customize ) {

		$wp_customize->add_setting( BoldThemesFramework::$pfx . '_theme_options[default_menu_weight]', array(
			'default'           => BoldThemes_Customize_Default::$data['default_menu_weight'],
			'type'              => 'option',
			'capability'        => 'edit_theme_options',
			'sanitize_callback' => 'boldthemes_sanitize_select'
		));
		$wp_customize->add_control( 'default_menu_weight', array(
			'label'     => esc_html__( 'Menu Font Weight', 'bambino' ),
			'section'   => BoldThemesFramework::$pfx . '_typo_section',
			'settings'  => BoldThemesFramework::$pfx . '_theme_options[default_menu_weight]',
			'priority'  => 111,
			'type'      => 'select',
			'choices'   => array(
				'default'		=> esc_html__( 'Default', 'bambino' ),
				'normal' 		=> esc_html__( 'Normal', 'bambino' ),
				'bold' 			=> esc_html__( 'Bold', 'bambino' ),
				'bolder' 		=> esc_html__( 'Bolder', 'bambino' ),
				'lighter' 		=> esc_html__( 'Lighter', 'bambino' ),
				'light' 		=> esc_html__( 'Light', 'bambino' ),
				'thin' 			=> esc_html__( 'Thin', 'bambino' ),
				'100' 			=> esc_html__( '100', 'bambino' ),
				'200' 			=> esc_html__( '200', 'bambino' ),
				'300' 			=> esc_html__( '300', 'bambino' ),
				'400' 			=> esc_html__( '400', 'bambino' ),
				'500' 			=> esc_html__( '500', 'bambino' ),
				'600' 			=> esc_html__( '600', 'bambino' ),
				'700' 			=> esc_html__( '700', 'bambino' ),
				'800' 			=> esc_html__( '800', 'bambino' ),
				'900' 			=> esc_html__( '900', 'bambino' )
			)
		));
	}
}
add_action( 'customize_register', 'boldthemes_customize_default_menu_weight' );
add_action( 'boldthemes_customize_register', 'boldthemes_customize_default_menu_weight' );


// MENU FONT SIZE
if ( ! function_exists( 'boldthemes_customize_menu_font_size' ) ) {
	function boldthemes_customize_menu_font_size( $wp_customize ) {
		
		$wp_customize->add_setting( BoldThemesFramework::$pfx . '_theme_options[menu_font_size]', array(
			'default'           => BoldThemes_Customize_Default::$data['menu_font_size'],
			'type'              => 'option',
			'capability'        => 'edit_theme_options',
			'sanitize_callback' => 'boldthemes_sanitize_select'
		));
		$wp_customize->add_control( 'menu_font_size', array(
			'label'     => esc_html__( 'Menu Font Size', 'bambino' ),
			'description'    => esc_html__( 'Set the font size you wish which will affect only the menu and menu widgets.', 'bambino' ),
			'section'   => BoldThemesFramework::$pfx . '_typo_section',
			'settings'  => BoldThemesFramework::$pfx . '_theme_options[menu_font_size]',
			'priority'  => 112,
			'type'      => 'select',
			'choices'   => array(
				'14'  	=> esc_html__( '14px', 'bambino' ),
				'15'  	=> esc_html__( '15px', 'bambino' ),
				'16'  	=> esc_html__( '16px', 'bambino' ),
				'17'  	=> esc_html__( '17px', 'bambino' ),
				'18'  	=> esc_html__( '18px', 'bambino' ),
			)
		));
	}
}
add_action( 'customize_register', 'boldthemes_customize_menu_font_size' );
add_action( 'boldthemes_customize_register', 'boldthemes_customize_menu_font_size' );


// CAPITALIZE MAIN MENU
BoldThemes_Customize_Default::$data['capitalize_main_menu'] = false;
if ( ! function_exists( 'boldthemes_customize_capitalize_main_menu' ) ) {
	function boldthemes_customize_capitalize_main_menu( $wp_customize ) {
		$wp_customize->add_setting( BoldThemesFramework::$pfx . '_theme_options[capitalize_main_menu]', array(
			'default'           => BoldThemes_Customize_Default::$data['capitalize_main_menu'],
			'type'              => 'option',
			'capability'        => 'edit_theme_options',
			'sanitize_callback' => 'boldthemes_sanitize_checkbox'
		));
		$wp_customize->add_control( 'capitalize_main_menu', array(
			'label'     => esc_html__( 'Capitalize Menu Items', 'bambino' ),
			'section'   => BoldThemesFramework::$pfx . '_typo_section',
			'settings'  => BoldThemesFramework::$pfx . '_theme_options[capitalize_main_menu]',
			'priority'  => 113,
			'type'      => 'checkbox'
		));
	}
}

add_action( 'customize_register', 'boldthemes_customize_capitalize_main_menu' );
add_action( 'boldthemes_customize_register', 'boldthemes_customize_capitalize_main_menu' );



// BUTTON COLORS
if ( ! function_exists( 'boldthemes_customize_accent_button_dark_text' ) ) {
	function boldthemes_customize_accent_button_dark_text( $wp_customize ) {
		
		$wp_customize->add_setting( BoldThemesFramework::$pfx . '_theme_options[accent_button_dark_text]', array(
			'default'           => BoldThemes_Customize_Default::$data['accent_button_dark_text'],
			'type'              => 'option',
			'capability'        => 'edit_theme_options',
			'sanitize_callback' => 'boldthemes_sanitize_checkbox'
		));
		$wp_customize->add_control( 'accent_button_dark_text', array(
			'label'    => esc_html__( 'Set all the buttons to have dark color text', 'bambino' ),
			'description'    => esc_html__( 'Enabling this will make all buttons throughout the theme (Blog, Portfolio, Shop etc.) to have dark color text instead of light color', 'bambino' ),
			'section'  => BoldThemesFramework::$pfx . '_typo_section',
			'settings' => BoldThemesFramework::$pfx . '_theme_options[accent_button_dark_text]',
			'priority' => 114,
			'type'     => 'checkbox'
		));	
	}
}
add_action( 'customize_register', 'boldthemes_customize_accent_button_dark_text' );
add_action( 'boldthemes_customize_register', 'boldthemes_customize_accent_button_dark_text' );


// HIGHLIGHT CURRENT PAGE
BoldThemes_Customize_Default::$data['highlight_current_page'] = 'dot';
if ( ! function_exists( 'boldthemes_customize_highlight_current_page' ) ) {
	function boldthemes_customize_highlight_current_page( $wp_customize ) {

		$wp_customize->add_setting( BoldThemesFramework::$pfx . '_theme_options[highlight_current_page]', array(
			'default'           => BoldThemes_Customize_Default::$data['highlight_current_page'],
			'type'              => 'option',
			'capability'        => 'edit_theme_options',
			'sanitize_callback' => 'boldthemes_sanitize_select'
		));
		$wp_customize->add_control( 'highlight_current_page', array(
			'label'     => esc_html__( 'Highlight Current Page', 'bambino' ),
			'section'  => BoldThemesFramework::$pfx . '_header_footer_section',
			'settings'  => BoldThemesFramework::$pfx . '_theme_options[highlight_current_page]',
			'priority'  => 104,
			'type'      => 'select',
			'choices'   => array(
				'default'	=> esc_html__( 'Underline', 'bambino' ),
				'dot' 		=> esc_html__( 'Dot', 'bambino' )
			)
		));
	}
}
add_action( 'customize_register', 'boldthemes_customize_highlight_current_page' );
add_action( 'boldthemes_customize_register', 'boldthemes_customize_highlight_current_page' );


// THIRD COLOR
if ( ! function_exists( 'boldthemes_customize_third_color' ) ) {
	function boldthemes_customize_third_color( $wp_customize ) {
		
		$wp_customize->add_setting( BoldThemesFramework::$pfx . '_theme_options[third_color]', array(
			'default'        	   => BoldThemes_Customize_Default::$data['third_color'],
			'type'           	   => 'option',
			'capability'     	   => 'edit_theme_options',
			'sanitize_callback'    => 'sanitize_hex_color'
		));
		$wp_customize->add_control( new WP_Customize_Color_Control( $wp_customize, 'third_color', array(
			'label'    => esc_html__( 'Third Color', 'bambino' ),
			'section'  => BoldThemesFramework::$pfx . '_general_section',
			'settings' => BoldThemesFramework::$pfx . '_theme_options[third_color]',
			'priority' => 26,
			'context'  => BoldThemesFramework::$pfx . '_third_color'
		)));
	}
}
add_action( 'customize_register', 'boldthemes_customize_third_color' );
add_action( 'boldthemes_customize_register', 'boldthemes_customize_third_color' );


// FOURTH COLOR
if ( ! function_exists( 'boldthemes_customize_fourth_color' ) ) {
	function boldthemes_customize_fourth_color( $wp_customize ) {
		
		$wp_customize->add_setting( BoldThemesFramework::$pfx . '_theme_options[fourth_color]', array(
			'default'        	   => BoldThemes_Customize_Default::$data['fourth_color'],
			'type'           	   => 'option',
			'capability'     	   => 'edit_theme_options',
			'sanitize_callback'    => 'sanitize_hex_color'
		));
		$wp_customize->add_control( new WP_Customize_Color_Control( $wp_customize, 'fourth_color', array(
			'label'    => esc_html__( 'Fourth Color', 'bambino' ),
			'section'  => BoldThemesFramework::$pfx . '_general_section',
			'settings' => BoldThemesFramework::$pfx . '_theme_options[fourth_color]',
			'priority' => 26,
			'context'  => BoldThemesFramework::$pfx . '_fourth_color'
		)));
	}
}
add_action( 'customize_register', 'boldthemes_customize_fourth_color' );
add_action( 'boldthemes_customize_register', 'boldthemes_customize_fourth_color' );



/* Helper function */
if ( ! function_exists( 'bambino_body_class' ) ) {
	function bambino_body_class( $extra_class ) {
		if ( boldthemes_get_option( 'default_heading_weight' ) ) {
			$extra_class[] =  'btHeadingWeight' . boldthemes_convert_param_to_camel_case ( boldthemes_get_option( 'default_heading_weight' ) );
		}
		if ( boldthemes_get_option( 'highlight_current_page' ) ) {
			$extra_class[] =  'btHighlightCurrentPage' . boldthemes_convert_param_to_camel_case ( boldthemes_get_option( 'highlight_current_page' ) );
		}
		if ( boldthemes_get_option( 'default_button_weight' ) ) {
			$extra_class[] =  'btButtonWeight' . boldthemes_convert_param_to_camel_case ( boldthemes_get_option( 'default_button_weight' ) );
		}
		if ( boldthemes_get_option( 'menu_font_size' ) ) {
			$extra_class[] =  'btMenuFontSize-' . boldthemes_convert_param_to_camel_case ( boldthemes_get_option( 'menu_font_size' ) );
		}
		return $extra_class;
	}
}