<?php

/**
 * Color schemes
 */

if ( ! function_exists( 'bambino_color_schemes' ) ) {
	function bambino_color_schemes( $color_scheme_arr ) {

		$theme_color_schemes = array();
		/* Color Scheme 01 */ $theme_color_schemes[] = 'dark-skin;Light font, dark background;#ffffff;#282828';
		/* Color Scheme 02 */ $theme_color_schemes[] = 'light-skin;Dark font, light background;#282828;#ffffff';
		
		/* Color Scheme 03 */ $theme_color_schemes[] = 'accent-light-skin;Accent font, dark background (or details);var(--accent-color);#282828';
		/* Color Scheme 04 */ $theme_color_schemes[] = 'accent-dark-skin;Accent font, light background (or details);var(--accent-color);#ffffff';

		/* Color Scheme 05 */ $theme_color_schemes[] = 'light-accent-skin;Dark font, accent background (or details);#282828;var(--accent-color)';
		/* Color Scheme 06 */ $theme_color_schemes[] = 'dark-accent-skin;Light font, accent background (or details);#ffffff;var(--accent-color)';
		
		/* Color Scheme 07 */ $theme_color_schemes[] = 'alternate-light-skin;Alternate font, dark background (or details);var(--alternate-color);#282828';
		/* Color Scheme 08 */ $theme_color_schemes[] = 'alternate-dark-skin;Alternate font, light background (or details);var(--alternate-color);#ffffff';

		/* Color Scheme 09 */ $theme_color_schemes[] = 'light-alternate-skin;Dark font, alternate background (or details);#282828;var(--alternate-color)';
		/* Color Scheme 10 */ $theme_color_schemes[] = 'dark-alternate-skin;Light font, alternate background (or details);#ffffff;var(--alternate-color)';

		/* Color Scheme 11 */ $theme_color_schemes[] = 'light-third-color-skin;Dark font, third accent color background (or details);#282828;var(--third-color)';
		/* Color Scheme 12 */ $theme_color_schemes[] = 'light-fourth-color-skin;Dark font, fourth accent color background (or details);#282828;var(--fourth-color)';

		/* Color Scheme 13 */ $theme_color_schemes[] = 'gray-background;Dark font, gray color background (or details);#181818;#efefef';

		/* Color Scheme 14 */ $theme_color_schemes[] = 'accent-alternate-skin;Accent font, alternate background (or details);var(--accent-color);var(--alternate-color)';
		/* Color Scheme 15 */ $theme_color_schemes[] = 'alternate-accent-skin;Alternate font, accent background (or details);var(--alternate-color);var(--accent-color)';

		/* Color Scheme 16 */ $theme_color_schemes[] = 'accent-third-color-skin;Accent font, third accent color background (or details);var(--accent-color);var(--third-color)';
		/* Color Scheme 17 */ $theme_color_schemes[] = 'alternate-fourth-color-skin;Alternate font, fourth accent color background (or details);var(--alternate-color);var(--fourth-color)';
		/* Color Scheme 18 */ $theme_color_schemes[] = 'third-accent-color-skin;Third color font, accent color background (or details);var(--third-color);var(--accent-color)';
		/* Color Scheme 19 */ $theme_color_schemes[] = 'fourth-alternate-color-skin;Fourth color font, alternate color background (or details);var(--fourth-color);var(--alternate-color)';


		/* Color Scheme 20 */ $theme_color_schemes[] = 'dark-third-color-skin;Light font, third accent color background (or details);#ffffff;var(--third-color)';
		/* Color Scheme 21 */ $theme_color_schemes[] = 'dark-fourth-color-skin;Light font, fourth accent color background (or details);#ffffff;var(--fourth-color)';

		/* Color Scheme 22 */ $theme_color_schemes[] = 'third-light-color-skin;Third accent color, dark font background (or details);var(--third-color);#282828';
		/* Color Scheme 23 */ $theme_color_schemes[] = 'fourth-light-color-skin;Fourth accent color, dark font background (or details);var(--fourth-color);#282828';

		/* Color Scheme 24 */ $theme_color_schemes[] = 'dark-beige-background;Dark font, beige color background (or details);#181818;#f7f6f5';

		/* Color Scheme 25 */ $theme_color_schemes[] = 'dark-gray-light-skin;Dark gray font, light color background (or details);#7C7C7C;#ffffff';
		/* Color Scheme 26 */ $theme_color_schemes[] = 'dark-gray-accent-skin;Dark gray font, accent color background (or details);#7C7C7C;var(--accent-color)';

		/* Color Scheme 27 */ $theme_color_schemes[] = 'third-dark-gray-skin;Third color font, dark gray background (or details);var(--third-color);#7C7C7C';

		return array_merge( $theme_color_schemes, $color_scheme_arr );
	}
}

/*

Black/White;#000;#fff
White/Black;#fff;#000
LightGray/Black;#e2e2e2;#000
Black/LightGray;#000;#e2e2e2
DarkGray/White;#333335;#fff
White/DarkGray;#fff;#333335

*/

/*
* set content width
*/
if ( ! isset( $content_width ) ) {
	$content_width = 1200;
}

/**
 * Change number of related products
 */
if ( ! function_exists( 'boldthemes_change_number_related_products' ) ) {
	function boldthemes_change_number_related_products( $args ) {
		$args['posts_per_page'] = 4; // # of related products
		$args['columns'] = 4; // # of columns per row
		return $args;
	}
}

/**
 * Loop shop per page
 */
 
if ( ! function_exists( 'boldthemes_loop_shop_per_page' ) ) {
	function boldthemes_loop_shop_per_page( $cols ) {
		return 9;
	}
}

/**
 * Loop columns
 */
if ( ! function_exists( 'boldthemes_loop_shop_columns' ) ) {
	function boldthemes_loop_shop_columns() {
		return 3; // 3 products per row
	}
}